/*
 * AutoRaster.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/AutoRaster.hpp"

namespace Graphics
{

struct AutoRasterTestClass
{
  AutoRasterTestClass(void):
    _size(10,20)
  {
  }

  AutoRaster<PixelMono> makeMono(void)
  {
    AutoRaster<PixelMono> m(_size);
    return m;
  }

  const Size _size;
};

} // namespace Graphics


namespace tut
{
typedef Graphics::AutoRasterTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/AutoRaster");
}

using namespace Graphics;

namespace tut
{

// check if basic construction was ok
template<>
template<>
void testObj::test<1>(void)
{
  AutoRaster<PixelMono> sr(_size);
  ensure( _size==sr->size() );
}

// test copyconstruction
template<>
template<>
void testObj::test<2>(void)
{
  makeMono();

  AutoRaster<PixelMono> sr1( makeMono() );
  ensure( sr1.get()  !=NULL  );
  ensure( sr1->size()==_size );

  AutoRaster<PixelMono> sr2=makeMono();
  ensure( sr2.get()  !=NULL  );
  ensure( sr2->size()==_size );
}

// check construction from raw pointer
template<>
template<>
void testObj::test<3>(void)
{
  RasterMono     *rm( new RasterMono(_size) );  // raw pointer is needed here!
  AutoRasterMono  ar(rm);
  ensure( ar.get()==rm );
}

// test assignment operator
template<>
template<>
void testObj::test<4>(void)
{
  AutoRasterMono ar1(_size);
  AutoRasterMono ar2(NULL);

  ensure( ar1.get()!=NULL );
  ensure( ar2.get()==NULL );
  ensure( ar1->size()==_size );

  ar2=ar1;
  ensure( ar1.get()==NULL );
  ensure( ar2.get()!=NULL );
  ensure( ar2->size()==_size );
}

} // namespace tut

