/*
 * Exception.hpp
 *
 * everything within this namespace should use this.
 *
 */
#ifndef INCLUDE_GRAPHICS_EXCEPTION_HPP_FILE
#define INCLUDE_GRAPHICS_EXCEPTION_HPP_FILE

/* public header */

#include <string>
#include <exception>


namespace Graphics
{


class Exception: public std::exception
{
public:
  explicit Exception(const std::string& msg) throw():
                _msg(msg)
  {
  }

  explicit Exception(const char msg[]) throw():
                _msg(msg)
  {
  }

  virtual ~Exception(void) throw()
  {
  }

  virtual const char *what(void) const throw()
  {
    return _msg.c_str();
  }

private:
  std::string _msg;
};


} // namespace Graphics


#endif

