/*
 * ColorConverterTransformation.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Filter/ColorConverterTransformation.hpp"

namespace Graphics
{
namespace Filter
{

struct ColorConverterTransformationTestClass
{
};

} // namespace Filter
} // namespace Graphics


namespace tut
{
typedef Graphics::Filter::ColorConverterTransformationTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Filter/ColorConverterTransformation");
}


using namespace boost;
using namespace Graphics;
using namespace Graphics::Filter;


namespace tut
{

// test if results matches those without transformation
template<>
template<>
void testObj::test<1>(void)
{
  // some random input raster
  SharedRasterRGB  rcIn  ( Size(5, 10) );
  // output raster after transfomration
  SharedRasterMono rgOutT( Size(5, 10) );
  // output raster after 'regular' scalling
  SharedRasterMono rgOutR( Size(5, 10) );

  ColorConverterTransformation<PixelMono, PixelRGB> cct(rgOutT, rcIn);
  cct.transform();
  ColorConverter<PixelMono, PixelRGB> cctTmp;
  cctTmp.filter( *rgOutR.get(), *rcIn.get() );

  for(unsigned int y=0; y<rgOutT->size().y(); ++y)
    for(unsigned int x=0; x<rgOutT->size().x(); ++x)
    {
      const Position  pos(x,y);
      const PixelMono p1=rgOutT->getPixel(pos);
      const PixelMono p2=rgOutR->getPixel(pos);
      ensure(p1.get()==p2.get());
    }
}

} // namespace tut

