/*
 * GeneralLayer.hpp
 *
 */
#ifndef INCLUDE_GRAPHICS_FILTER_GENERALLAYER_HPP_FILE
#define INCLUDE_GRAPHICS_FILTER_GENERALLAYER_HPP_FILE

/* public header */

#include "Graphics/RasterLayer.hpp"
#include "Graphics/Filter/General.hpp"
#include "Graphics/Exception.hpp"


namespace Graphics
{
namespace Filter
{

//
// generic class - input and output types may differ
//
template <typename TPixOut, typename TPixIn, typename TPixOp>
class GeneralLayerAny: public GeneralAny< RasterLayer<TPixOut>,
                                          RasterLayer<TPixIn>,
                                          TPixOp >
{
public:
  typedef RasterLayer<TPixIn>  TRasterLayerIn;
  typedef RasterLayer<TPixOut> TRasterLayerOut;

  GeneralLayerAny(const TPixOp &op):
    GeneralAny<TRasterLayerOut, TRasterLayerIn, TPixOp>(op)
  {
  }
}; // class GeneralLayerAny


//
// class version assuming having the same in/out
// raster types.
//
template <typename TPixel, typename TPixOp>
class GeneralLayer: public GeneralLayerAny<TPixel, TPixel, TPixOp>
{
public:
  GeneralLayer(const TPixOp &op):
    GeneralLayerAny<TPixel, TPixel, TPixOp>(op)
  {
  }
}; // class GeneralLayer

} // namespace Filter
} // namespace graphics

#endif

