/*
 * GeneralLayerTwo.t.cpp
 *
 */
#include <tut.h>

#include <algorithm>

#include "Graphics/Filter/GeneralLayerTwo.hpp"


namespace
{
struct SomeTestOperation
{
  Graphics::color operator()(const Graphics::Position        &pos,
                             const Graphics::RasterLayerMono &in1,
                             const Graphics::RasterLayerMono &in2) const
  {
    const Graphics::color &pIn1=in1.getPixel(pos);
    const Graphics::color &pIn2=in2.getPixel(pos);
    return std::min(pIn1, pIn2);
  }
}; // struct SomeTestOperation

} // unnamed namespace


namespace Graphics
{
namespace Filter
{

struct GeneralLayerTwoTestClass
{
  GeneralLayerTwoTestClass(void):
    _size(4,3),
    _in1 (_size),
    _in1l( makeRasterLayerMono(&_in1) ),
    _in2 (_size),
    _in2l( makeRasterLayerMono(&_in2) ),
    _out (_size),
    _outl( makeRasterLayerMono(&_out) ),
    _gf  (_sto)
  {
  }

  const Size        _size;

  RasterMono        _in1;
  RasterLayerMono   _in1l;

  RasterMono        _in2;
  RasterLayerMono   _in2l;

  RasterMono        _out;
  RasterLayerMono   _outl;

  SomeTestOperation _sto;
  GeneralLayerTwo<PixelMono, SomeTestOperation> _gf;
};

} // namespace Filter
} // namespace Graphics


namespace tut
{
typedef Graphics::Filter::GeneralLayerTwoTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Filter/GeneralLayerTwo");
}


using namespace Graphics;
using namespace Graphics::Filter;

namespace tut
{

// test if it works in regular conditions
template<>
template<>
void testObj::test<1>(void)
{
  // fransform manualy
  for(unsigned int y=0; y<_in1.size().y(); ++y)
    for(unsigned int x=0; x<_in1.size().x(); ++x)
    {
      const Position pos(x,y);
      _outl.setPixel( pos, _sto(pos, _in1l, _in2l) );
    }

  // make automatic transform
  RasterMono      out2(_size);
  RasterLayerMono out2l=makeRasterLayerMono(&out2);
  _gf.filter(out2l, _in1l, _in2l);

  // compare automatic and manual results
  for(unsigned int y=0; y<_out.size().y(); ++y)
    for(unsigned int x=0; x<_out.size().x(); ++x)
    {
      const Position   pos(x,y);
      const PixelMono &p1=out2.getPixel(pos);
      const PixelMono &p2=_out.getPixel(pos);
      ensure(p1.get()==p2.get());
    }
}

} // namespace tut

