/*
 * GeneralRasterTransformation.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Filter/GeneralRasterTransformation.hpp"

namespace Graphics
{
namespace Filter
{

struct GeneralRasterTransformationTestClass
{
};

} // namespace Filter
} // namespace Graphics


namespace tut
{
typedef Graphics::Filter::GeneralRasterTransformationTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Filter/GeneralRasterTransformation");
}


using namespace boost;
using namespace Graphics;
using namespace Graphics::Filter;

namespace
{
struct SomeTestOperation
{
  Graphics::PixelMono operator()(const Graphics::Position   &pos,
                                 const Graphics::RasterMono &in) const
  {
    const Graphics::PixelMono &pIn=in.getPixel(pos);
    return Graphics::PixelMono( (pIn.get()<255)?(pIn.get()+1):255 );
  }
}; // struct SomeTestOperation
} // unnamed namespace



namespace tut
{

// test filtering via Transformation and check if it matches
template<>
template<>
void testObj::test<1>(void)
{
  // some random input raster
  const Size size(10,20);
  SharedRasterMono rgIn  (size);
  SharedRasterMono rgOutT(size);
  // output raster after 'regular' filtering
  SharedRasterMono rgOutR(size);

  SomeTestOperation sto;
  GeneralRasterTransformation<PixelMono, SomeTestOperation>
                                gft(sto, rgOutT, rgIn);
  gft.transform();
  GeneralRaster<PixelMono, SomeTestOperation> grTmp(sto);
  grTmp.filter( *rgOutR.get(), *rgIn.get() );

  for(unsigned int y=0; y<rgOutT->size().y(); ++y)
    for(unsigned int x=0; x<rgOutT->size().x(); ++x)
    {
      const Position  pos(x,y);
      const PixelMono p1=rgOutT->getPixel(pos);
      const PixelMono p2=rgOutR->getPixel(pos);
      ensure(p1.get()==p2.get());
    }
}

} // namespace tut

