/*
 * GeneralRasterTwo.t.cpp
 *
 */
#include <tut.h>

#include <algorithm>

#include "Graphics/Filter/GeneralRasterTwo.hpp"


namespace
{
struct SomeTestOperation
{
  Graphics::PixelMono operator()(const Graphics::Position   &pos,
                                 const Graphics::RasterMono &in1,
                                 const Graphics::RasterMono &in2) const
  {
    const Graphics::PixelMono &pIn1=in1.getPixel(pos);
    const Graphics::PixelMono &pIn2=in2.getPixel(pos);
    return Graphics::PixelMono( std::min(pIn1.get(), pIn2.get()) );
  }
}; // struct SomeTestOperation

} // unnamed namespace


namespace Graphics
{
namespace Filter
{

struct GeneralRasterTwoTestClass
{
  GeneralRasterTwoTestClass(void):
    _size(4,3),
    _in1(_size),
    _in2(_size),
    _out(_size),
    _gf (_sto)
  {
  }

  const Size        _size;
  RasterMono        _in1;
  RasterMono        _in2;
  RasterMono        _out;
  SomeTestOperation _sto;
  GeneralRasterTwo<PixelMono, SomeTestOperation> _gf;
};

} // namespace Filter
} // namespace Graphics


namespace tut
{
typedef Graphics::Filter::GeneralRasterTwoTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Filter/GeneralRasterTwo");
}


using namespace Graphics;
using namespace Graphics::Filter;

namespace tut
{

// test if it works in regular conditions
template<>
template<>
void testObj::test<1>(void)
{
  // fransform manualy
  for(unsigned int y=0; y<_in1.size().y(); ++y)
    for(unsigned int x=0; x<_in1.size().x(); ++x)
    {
      const Position pos(x,y);
      _out.setPixel( pos, _sto(pos, _in1, _in2) );
    }

  // make automatic transform
  AutoRasterMono ar=_gf.filterNew(_in1, _in2);

  // compare automatic and manual results
  for(unsigned int y=0; y<ar->size().y(); ++y)
    for(unsigned int x=0; x<ar->size().x(); ++x)
    {
      const Position   pos(x,y);
      const PixelMono &p1=ar->getPixel(pos);
      const PixelMono &p2=_out.getPixel(pos);
      ensure(p1.get()==p2.get());
    }
}

} // namespace tut

