/*
 * Median.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Filter/Median.hpp"


namespace Graphics
{
namespace Filter
{

struct MedianTestClass
{
  MedianTestClass(void):
    _size(3,3),
    _in (_size),
    _inl( makeRasterLayerMono(&_in) ),
    _out(_size),
    _outl( makeRasterLayerMono(&_out) ),
    _mft(_outl, _inl)
  {
    _in.setPixel( Position(0,0), PixelMono(111) );
    _in.setPixel( Position(1,0), PixelMono(222) );
    _in.setPixel( Position(2,0), PixelMono(123) );
    _in.setPixel( Position(0,1), PixelMono(234) );
    _in.setPixel( Position(1,1), PixelMono( 90) );
    _in.setPixel( Position(2,1), PixelMono(100) );
    _in.setPixel( Position(0,2), PixelMono( 64) );
    _in.setPixel( Position(1,2), PixelMono( 21) );
    _in.setPixel( Position(2,2), PixelMono(  9) );
  }

  const Size           _size;
  RasterMono           _in;
  RasterLayerMono      _inl;
  RasterMono           _out;
  RasterLayerMono      _outl;
  Median<PixelMono>               _mf;
  MedianTransformation<PixelMono> _mft;
};

} // namespace Filter
} // namespace Graphics


namespace tut
{
typedef Graphics::Filter::MedianTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Filter/Median");
}


using namespace Graphics;
using namespace Graphics::Filter;

namespace tut
{

// test if it works in regular conditions
template<>
template<>
void testObj::test<1>(void)
{
  _mft.transform();     // test if it runs without errors
}

// check getting of pixel
template<>
template<>
void testObj::test<2>(void)
{
  MedianProcessor<PixelMono> mfp;
  const color                pm=mfp( Position(1,1), _inl );
  ensure(pm==100);
}

} // namespace tut

