/*
 * SobelEdge.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Filter/SobelEdge.hpp"


namespace Graphics
{
namespace Filter
{

struct SobelEdgeTestClass
{
  SobelEdgeTestClass(void):
    _size (3,3),
    _inM  (_size),
    _inMl ( makeRasterLayerMono(&_inM)  ),
    _outM (_size),
    _outMl( makeRasterLayerMono(&_outM) ),
    _l    (PixelRGB::Layer::G),
    _inC  (_size),
    _inCl ( makeRasterLayerRGB(&_inC, _l)  ),
    _outC (_size),
    _outCl( makeRasterLayerRGB(&_outC, _l) )
  {
  }

  const Size      _size;

  RasterMono      _inM;
  RasterLayerMono _inMl;
  RasterMono      _outM;
  RasterLayerMono _outMl;

  PixelRGB::Layer _l;
  RasterRGB       _inC;
  RasterLayerRGB  _inCl;
  RasterRGB       _outC;
  RasterLayerRGB  _outCl;
};

} // namespace Filter
} // namespace Graphics


namespace tut
{
typedef Graphics::Filter::SobelEdgeTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Filter/SobelEdge");
}


using namespace Graphics;
using namespace Graphics::Transform;
using namespace Graphics::Filter;

namespace tut
{

// basic test for mono
template<>
template<>
void testObj::test<1>(void)
{
  SobelEdge<PixelMono> sem;
  sem.filter(_outMl, _inMl);
}

// basic test for RGB
template<>
template<>
void testObj::test<2>(void)
{
  SobelEdge<PixelRGB> sec;
  sec.filter(_outCl, _inCl);
}

} // namespace tut

