/*
 * PixelConverter.t.cpp
 *
 */
#include <tut.h>
#include <math.h>
#include <string>

#include "Graphics/Helpers/MagickPP/PixelConverter.hpp"

namespace Graphics
{
namespace Helpers
{
namespace MagickPP
{

struct PixelConverterTestClass
{
};

} // namespace MagickPP
} // namespace Helpers
} // namespace Graphics


namespace tut
{
typedef Graphics::Helpers::MagickPP::PixelConverterTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Helpers/MagickPP/PixelConverter");
const double eps=255*(1.0/100); // 1% error is acceptable
}


using namespace std;
using namespace Magick;
using namespace Graphics;
using namespace Graphics::Helpers::MagickPP;

namespace tut
{

// test gray pixel
template<>
template<>
void testObj::test<1>(void)
{
  ColorRGB pIn(0.1, 0.2, 0.3);
  PixelRGB pOut;
  PixelConverter()(pOut, pIn);
  ensure( fabs(pOut.getR()-pIn.red()  *255)<eps );
  ensure( fabs(pOut.getG()-pIn.green()*255)<eps );
  ensure( fabs(pOut.getB()-pIn.blue() *255)<eps );
}

// test rgb pixel
template<>
template<>
void testObj::test<2>(void)
{
  PixelRGB pIn (10,  100, 200);
  ColorRGB pOut(0.1, 0.2, 0.3);
  PixelConverter()(pOut, pIn);
  ensure( fabs(pIn.getR()-pOut.red()  *255)<eps );
  ensure( fabs(pIn.getG()-pOut.green()*255)<eps );
  ensure( fabs(pIn.getB()-pOut.blue() *255)<eps );
}

// test for potentialy exceptional cases
// (due to soemthing that looks like a bug within Magic++).
// wrapper has been provided, so that this should not happen.
template<>
template<>
void testObj::test<3>(void)
{
  Image    img( Geometry(2,3), ColorRGB(1,1,1) );
  ColorRGB pix=PixelConverter().operator()<ColorRGB, PixelRGB>
                                    ( PixelRGB(0,0,0) );
  img.pixelColor(0,0, pix);
}


} // namespace tut

