/*
 * Color.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Raster.hpp"
#include "Graphics/Histogram/Color.hpp"

namespace Graphics
{
namespace Histogram
{

struct ColorTestClass
{
};

} // namespace Histogram
} // namespace Graphics


namespace tut
{
typedef Graphics::Histogram::ColorTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Histogram/Color");
}


using namespace Graphics;
using namespace Graphics::Histogram;

namespace tut
{

// just test if it builds fine
template<>
template<>
void testObj::test<1>(void)
{
  RasterRGB           r ( Size(10,20) );
  RasterLayerRGB      rl(&r, PixelRGB::Layer::B);
  ColorBase<PixelRGB> hc(rl);
}

// test if 'typedefs' build fine too
template<>
template<>
void testObj::test<2>(void)
{
  const Size s(10,2);
  RasterMono rMono(s);
  RasterRGB  rRGB(s);

  RasterLayerMono rlMono=makeRasterLayerMono(&rMono);
  RasterLayerRGB  rlRGB (&rRGB, PixelRGB::Layer::B);

  Mono mono(rlMono);
  RGB  rgb (rlRGB );
}

// try building & running transformation
template<>
template<>
void testObj::test<3>(void)
{
  const Size s(10,2);
  RasterMono rMono(s);
  RasterRGB  rRGB(s);

  RasterLayerMono rlMono=makeRasterLayerMono(&rMono);
  RasterLayerRGB  rlRGB (&rRGB, PixelRGB::Layer::B);

  MonoTransformation monoT(rlMono);
  RGBTransformation  rgbT (rlRGB );

  monoT.transform();
  rgbT.transform();
}

} // namespace tut

