/*
 * General.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Mask/General.hpp"

namespace Graphics
{
namespace Mask
{

struct GeneralTestClass: public General<double>
{
  GeneralTestClass(void):
    General<double>(3)
  {
    add( Offset(-1,-2), 6.0 );
    add( Offset( 1, 2), 6.1 );
    add( Offset(-4, 3), 6.2 );
  }
};

} // namespace Mask
} // namespace Graphics


namespace tut
{
typedef Graphics::Mask::GeneralTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Mask/General");
}


using namespace Graphics;
using namespace Graphics::Mask;

namespace tut
{

// test begin()
template<>
template<>
void testObj::test<1>(void)
{
  ensure( (*begin()).second==6.0 );
  Offset o=(*begin()).first;
  ensure( o.getX()==-1 );
  ensure( o.getY()==-2 );
}

// test begin->end iteration
template<>
template<>
void testObj::test<2>(void)
{
  double t[]={6.0, 6.1, 6.2};
  int    i  =0;
  for(const_iterator it=begin(); it!=end(); ++it, ++i)
    ensure( (*it).second==t[i] );
}

} // namespace tut

