/*
 * Offset.hpp
 *
 * representation of offset on the image.
 *
 */
#ifndef INCLUDE_GRAPHICS_OFFSET_HPP_FILE
#define INCLUDE_GRAPHICS_OFFSET_HPP_FILE

/* public header */

namespace Graphics
{

class Offset
{
public:
  // this construcor is only to be used in some
  // containers and should not be used outside.
  Offset(void):
    _x(0),
    _y(0)
  {
  }
  Offset(int x, int y):
    _x(x),
    _y(y)
  {
  }

  int getX(void) const
  {
    return _x;
  }
  int getY(void) const
  {
    return _y;
  }

private:
  int _x;
  int _y;
}; // class Offset

} // namespace Graphics

#endif

