/*
 * Pixel.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Pixel.hpp"

namespace Graphics
{

struct PixelTestClass: public PixelBase<int, 2>
{
};

} // namespace Graphics


namespace tut
{
typedef Graphics::PixelTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Pixel");
}


using namespace Graphics;

namespace tut
{

// test gray pixel
template<>
template<>
void testObj::test<1>(void)
{
  PixelMono p(66);
  ensure(p.get()==66);
}

// test rgb pixel
template<>
template<>
void testObj::test<2>(void)
{
  PixelRGB p(1,2,3);
  ensure(p.getR()==1);
  ensure(p.getG()==2);
  ensure(p.getB()==3);
}

// test pixel base class
template<>
template<>
void testObj::test<3>(void)
{
  PixelTestClass     pt;
  PixelBase<int, 2> &p=pt;
  p.layer(0,  66);
  p.layer(1, -13);
  ensure( p.layer(0)== 66 );
  ensure( p.layer(1)==-13 );
}

// test binary pixel
template<>
template<>
void testObj::test<4>(void)
{
  PixelBinary p(true);
  ensure(p.get()==true);
}

// test PixelLayer
template<>
template<>
void testObj::test<5>(void)
{
  PixelLayer<double> p(3.14);
  ensure(p.get()==3.14);

  p.set(2.79);
  ensure(p.get()==2.79);
}

} // namespace tut

