/*
 * PixelAdder.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/PixelTransform/PixelAdder.hpp"

namespace Graphics
{
namespace PixelTransform
{

struct PixelAdderTestClass
{
};

} // namespace PixelTransform
} // namespace Graphics


namespace tut
{
typedef Graphics::PixelTransform::PixelAdderTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/PixelTransform/PixelAdder");
}


using namespace Graphics;
using namespace Graphics::PixelTransform;

namespace tut
{

// test gray pixel
template<>
template<>
void testObj::test<1>(void)
{
  PixelAdder pa;
  PixelMono  p1(100);
  PixelMono  p2(110);
  PixelMono  p3(210);

  // value in range
  ensure( pa(p1,p2).get()==210 );
  // overflow - should take minimum
  ensure( pa(p2,p3).get()==255 );
}

// test rgb pixel
template<>
template<>
void testObj::test<2>(void)
{
  PixelAdder pa;
  PixelRGB   p1(100, 20,  50);
  PixelRGB   p2(110, 240, 80);
  PixelRGB   out;

  pa(out, p1,p2);
  ensure( out.getR()==210 && out.getG()==255 && out.getB()==130 );
}

// test binary pixel
template<>
template<>
void testObj::test<3>(void)
{
  PixelAdder  pa;
  PixelBinary p1(false);
  PixelBinary p2(true );
  PixelBinary p3(false);
  PixelBinary out1;
  PixelBinary out2;

  pa(out1, p1,p2);
  pa(out2, p1,p3);
  ensure( out1.get()==true  );
  ensure( out2.get()==false );
}

} // namespace tut

