/*
 * PixelDiffer.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/PixelTransform/PixelDiffer.hpp"

namespace Graphics
{
namespace PixelTransform
{

struct PixelDifferTestClass
{
};

} // namespace PixelTransform
} // namespace Graphics


namespace tut
{
typedef Graphics::PixelTransform::PixelDifferTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/PixelTransform/PixelDiffer");
}


using namespace Graphics;
using namespace Graphics::PixelTransform;

namespace tut
{

// test gray pixel
template<>
template<>
void testObj::test<1>(void)
{
  PixelDiffer pd;
  PixelMono   p1(100);
  PixelMono   p2(110);

  // values should by abs()'ed
  ensure( pd(p1,p2).get()==10 );
  ensure( pd(p2,p1).get()==10 );
}

// test rgb pixel
template<>
template<>
void testObj::test<2>(void)
{
  PixelDiffer pd;
  PixelRGB    p1(100, 20, 50);
  PixelRGB    p2(110, 40, 80);
  PixelRGB    out;

  // values should by abs()'ed
  pd(out, p1,p2);
  ensure( out.getR()==10 && out.getG()==20 && out.getB()==30 );

  // ...
  pd(out, p2,p1);
  ensure( out.getR()==10 && out.getG()==20 && out.getB()==30 );
}

// test binary pixel
template<>
template<>
void testObj::test<3>(void)
{
  PixelDiffer pd;
  PixelBinary p1(true );
  PixelBinary p2(false);
  PixelBinary p3(true );
  PixelBinary out1;
  PixelBinary out2;

  pd(out1, p1,p2);
  ensure(out1.get()==true );

  pd(out2, p1,p3);
  ensure(out2.get()==false);
}

} // namespace tut

