/*
 * Resizer.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Scale/Resizer.hpp"

namespace Graphics
{
namespace Scale
{

struct ResizerTestClass: public Resizer<PixelMono>
{
  ResizerTestClass(void):
    _sIn (10,20),
    _sOut(20,30),
    _s1(111,222),
    _s2(333,444),
    _rIn (_sIn ),
    _rOut(_sOut)
  {
  }

  virtual void resize(      TRaster &rOut,
                      const TRaster &rIn  )
  {
    _s1=rIn.size();
    _s2=rOut.size();
  }

  Size _sIn;
  Size _sOut;
  Size _s1;
  Size _s2;

  RasterMono _rIn;
  RasterMono _rOut;
};

} // namespace Scale
} // namespace Graphics


namespace tut
{
typedef Graphics::Scale::ResizerTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Scale/Resizer");
}


using namespace Graphics;
using namespace Graphics::Scale;

namespace tut
{

// try calling resize(img1, img2) directly
template<>
template<>
void testObj::test<1>(void)
{
  resize(_rOut, _rIn);
  ensure( _s1==_rIn.size()  );
  ensure( _s2==_rOut.size() );
}

// test running resize(img1, img2) indirectly via
// resize(size, img2)
template<>
template<>
void testObj::test<2>(void)
{
  AutoRasterMono ar=resizeToNew(_sOut, _rIn);
  ensure( _s1==_rIn.size() );
  ensure( _s2==ar->size()  );
}

} // namespace tut

