/*
 * SimpleTransformation.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Scale/SimpleTransformation.hpp"

namespace Graphics
{
namespace Scale
{

struct SimpleTransformationTestClass
{
};

} // namespace Scale
} // namespace Graphics


namespace tut
{
typedef Graphics::Scale::SimpleTransformationTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Scale/SimpleTransformation");
}


using namespace boost;
using namespace Graphics;
using namespace Graphics::Transform;
using namespace Graphics::Scale;

namespace tut
{

template<>
template<>
void testObj::test<1>(void)
{
  // some random input raster
  SharedRasterMono rgIn  ( Size(10, 20) );
  // output raster after transfomration
  SharedRasterMono rgOutT( Size(5,  10) );
  // output raster after 'regular' scalling
  SharedRasterMono rgOutR( Size(5,  10) );

  SimpleTransformation<PixelMono> rst(rgOutT, rgIn);
  rst.transform();

  Simple<PixelMono>().resize( *rgOutR.get(), *rgIn.get() );

  for(unsigned int y=0; y<rgOutT->size().y(); ++y)
    for(unsigned int x=0; x<rgOutT->size().x(); ++x)
    {
      const Position  pos(x,y);
      const PixelMono p1=rgOutT->getPixel(pos);
      const PixelMono p2=rgOutR->getPixel(pos);
      ensure(p1.get()==p2.get());
    }
}

} // namespace tut

