/*
 * SharedRaster.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/SharedRaster.hpp"

namespace Graphics
{

struct SharedRasterTestClass
{
  SharedRasterTestClass(void):
    _size(10,20)
  {
  }

  SharedRasterMono makeMono(void)
  {
    SharedRasterMono m(_size);
    return m;
  }

  const Size _size;
};

} // namespace Graphics


namespace tut
{
typedef Graphics::SharedRasterTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/SharedRaster");
}


using namespace Graphics;

namespace tut
{

// check if basic construction was ok
template<>
template<>
void testObj::test<1>(void)
{
  SharedRasterMono sr(_size);
  ensure( _size==sr->size() );
}

// test copyconstructing
template<>
template<>
void testObj::test<2>(void)
{
  SharedRasterMono sm=makeMono();
}

// test building from pointer
template<>
template<>
void testObj::test<3>(void)
{
  RasterMono       *rm( new RasterMono(_size) );    // we need raw pointer here...
  SharedRasterMono  sm(rm);
  ensure( sm.get()==rm );
}

} // namespace tut

