/*
 * SharedSyncRaster.hpp
 *
 * thread safe version of Raster class - copyable version.
 *
 */
#ifndef INCLUDE_GRAPHICS_SHAREDSYNCRASTER_HPP_FILE
#define INCLUDE_GRAPHICS_SHAREDSYNCRASTER_HPP_FILE

/* public header */

#include "System/Threads/SharedSyncObj.hpp"
#include "Graphics/SyncRaster.hpp"


namespace Graphics
{

template<typename TPixel>
class SharedSyncRaster: public
            System::Threads::SharedSyncObj< SyncRaster<TPixel> >
{
public:
  typedef SyncRaster<TPixel>                                   TSyncRaster;
  typedef System::Threads::SharedSyncObj< SyncRaster<TPixel> > TBase;

  explicit SharedSyncRaster(const Graphics::Size &size):
    TBase( new TSyncRaster(size) )
  {
  }

private:
}; // class SharedSyncRaster

//
// here are some commonly used definitions
//
typedef SharedSyncRaster<PixelRGB>    SharedSyncRasterRGB;
typedef SharedSyncRaster<PixelMono>   SharedSyncRasterMono;
typedef SharedSyncRaster<PixelBinary> SharedSyncRasterBinary;

} // namespace Graphics

#endif

