/*
 * SharedSyncRaster.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/SharedSyncRaster.hpp"

namespace Graphics
{

struct SharedSyncRasterTestClass
{
  SharedSyncRasterTestClass(void):
    _size(10,20)
  {
  }

  const Size _size;
};

} // namespace Graphics


namespace tut
{
typedef Graphics::SharedSyncRasterTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/SharedSyncRaster");
}


using namespace Graphics;

namespace tut
{

// check if basic construction was ok
template<>
template<>
void testObj::test<1>(void)
{
  SharedSyncRasterMono ssr(_size);
  // critical section
  {
    SharedSyncRasterMono::ExtLock el(ssr);
    ensure( _size==ssr(el)->size() );
  }
}

// see if rest of types works as well
template<>
template<>
void testObj::test<2>(void)
{
  SharedSyncRasterRGB    ssrc(_size);
  SharedSyncRasterMono   ssrm(_size);
  SharedSyncRasterBinary ssrb(_size);
}

} // namespace tut

