/*
 * SharedSyncRasterLayer.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/SharedSyncRasterLayer.hpp"

namespace Graphics
{

struct SharedSyncRasterLayerTestClass
{
  SharedSyncRasterLayerTestClass(void):
    _size(10,20),
    _r(_size),
    _layerNo(0)
  {
  }

  const Size _size;
  RasterRGB  _r;
  size_t     _layerNo;
};

} // namespace Graphics


namespace tut
{
typedef Graphics::SharedSyncRasterLayerTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/SharedSyncRasterLayer");
}


using namespace Graphics;

namespace tut
{

// check if basic construction was ok
template<>
template<>
void testObj::test<1>(void)
{
  SharedSyncRasterLayerRGB ssr(&_r, _layerNo);
  // critical section
  {
    SharedSyncRasterLayerRGB::ExtLock el(ssr);
    ensure( _size==ssr(el)->size() );
  }
}

// see if rest of types works as well
template<>
template<>
void testObj::test<2>(void)
{
  RasterRGB    rRGB   (_size);
  RasterMono   rMono  (_size);
  RasterBinary rBinary(_size);

  SharedSyncRasterLayerRGB    ssrc(&rRGB,    _layerNo);
  SharedSyncRasterLayerMono   ssrm(&rMono,   _layerNo);
  SharedSyncRasterLayerBinary ssrb(&rBinary, _layerNo);
}

} // namespace tut

