/*
 * Size.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Size.hpp"

namespace Graphics
{

struct SizeTestClass
{
  SizeTestClass():
    _s1(2,3),
    _s2(5,4)
  {
  }

  Size _s1;
  Size _s2;
};

} // namespace Graphics


namespace tut
{
typedef Graphics::SizeTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Size");
}


using namespace Graphics;

namespace tut
{

// test constructor
template<>
template<>
void testObj::test<1>(void)
{
  try
  {
    Size s(0,2);
    fail("constructor didn't throw");
  }
  catch(...) { /* should throw */ }
  try
  {
    Size s(3,0);
    fail("constructor didn't throw");
  }
  catch(...) { /* should throw */ }

  ensure( _s1.x()==2 && _s1.y()==3 );
}

// check 'inRange()'
template<>
template<>
void testObj::test<2>(void)
{
  Position in (1,2);
  Position out(10,20);
  ensure( _s1.inRange (in ) );
  ensure( !_s1.inRange(out) );
}

// (in)equality
template<>
template<>
void testObj::test<3>(void)
{
  ensure( _s1!=_s2 );
  _s1=_s2;
  ensure( _s2==_s1 );
}

// test size copmarison
template<>
template<>
void testObj::test<4>(void)
{
  ensure( _s1<_s2 );

  Size small1( 1,10);
  Size small2(10, 1);
  ensure( !(small1<_s1) );
  ensure( !(small2<_s1) );
}

// test setting indyvidual parameters
template<>
template<>
void testObj::test<5>(void)
{
  _s1.x(400);
  _s1.y(300);
  ensure( _s1.x()==400 && _s1.y()==300 );
}

} // namespace tut

