/*
 * StorerByExt.cpp
 *
 */

#include "Graphics/Storage/StorerByExt.hpp"
#include "Graphics/Helpers/MagickPP/RasterConverter.hpp"

using namespace boost;
using namespace Magick;


namespace Graphics
{
namespace Storage
{

void StorerByExt::read(void)
{
  // read image from file
  Image img;
  img.read( getFileName() );

  // if needed, resize raster to proper size
  const Size &size=_raster->size();
  if( size.x()!=img.columns() ||
      size.y()!=img.rows()       )
    *_raster.get()=RasterRGB( Size( img.columns(), img.rows() ) );

  // make convertion
  Helpers::MagickPP::RasterConverter()( *_raster.get(), img );
}


void StorerByExt::write(void)
{
  // make image of equal size
  const Size &size=_raster->size();
  Image img( Geometry( size.x(), size.y() ), ColorRGB(0,0,0) );

  // convert 'Raster' to 'Image'
  Helpers::MagickPP::RasterConverter()( img, *_raster.get() );
  img.write( getFileName() );
}

} // namespace Storage
} // namespace Graphics

