/*
 * SyncRaster.hpp
 *
 * thread safe version of Raster class.
 *
 */
#ifndef INCLUDE_GRAPHICS_SYNCRASTER_HPP_FILE
#define INCLUDE_GRAPHICS_SYNCRASTER_HPP_FILE

/* public header */

#include "System/Threads/SyncObj.hpp"
#include "Graphics/Raster.hpp"


namespace Graphics
{

template<typename TPixel>
class SyncRaster: public System::Threads::SyncObj< Raster<TPixel> >
{
public:
  explicit SyncRaster(const Graphics::Size &size):
    _r(size)
  {
    // initialize base class with proper Raster pointer
    init(&_r);
  }

private:
  Raster<TPixel> _r;
}; // class SyncRaster

//
// here are some commonly used definitions
//
typedef Graphics::SyncRaster<Graphics::PixelRGB>    SyncRasterRGB;
typedef Graphics::SyncRaster<Graphics::PixelMono>   SyncRasterMono;
typedef Graphics::SyncRaster<Graphics::PixelBinary> SyncRasterBinary;

} // namespace Graphics

#endif

