/*
 * SyncRaster.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/SyncRaster.hpp"

namespace Graphics
{

struct SyncRasterTestClass
{
  SyncRasterTestClass(void):
    _size(10,20)
  {
  }

  const Size _size;
};

} // namespace Graphics


namespace tut
{
typedef Graphics::SyncRasterTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/SyncRaster");
}


using namespace Graphics;

namespace tut
{

// check if basic construction was ok
template<>
template<>
void testObj::test<1>(void)
{
  SyncRasterMono sr(_size);
  // critical section
  {
    SyncRasterMono::ExtLock el(sr);
    ensure( _size==sr(el)->size() );
  }
}

// see if rest of types works as well
template<>
template<>
void testObj::test<2>(void)
{
  SyncRasterRGB    src(_size);
  SyncRasterMono   srm(_size);
  SyncRasterBinary srb(_size);
}

} // namespace tut

