/*
 * SyncRasterLayer.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/SyncRasterLayer.hpp"

namespace Graphics
{

struct SyncRasterLayerTestClass
{
  SyncRasterLayerTestClass(void):
    _size(10,20),
    _r(_size),
    _layerNo(0)
  {
  }

  const Size _size;
  RasterRGB  _r;
  size_t     _layerNo;
};

} // namespace Graphics


namespace tut
{
typedef Graphics::SyncRasterLayerTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/SyncRasterLayer");
}


using namespace Graphics;

namespace tut
{

// check if basic construction was ok
template<>
template<>
void testObj::test<1>(void)
{
  SyncRasterLayerRGB sr(&_r, _layerNo);
  // critical section
  {
    SyncRasterLayerRGB::ExtLock el(sr);
    ensure( _size==sr(el)->size() );
  }
}

// see if rest of types works as well
template<>
template<>
void testObj::test<2>(void)
{
  RasterRGB    rRGB   (_size);
  RasterMono   rMono  (_size);
  RasterBinary rBinary(_size);

  SyncRasterLayerRGB    src(&rRGB,    _layerNo);
  SyncRasterLayerMono   srm(&rMono,   _layerNo);
  SyncRasterLayerBinary srb(&rBinary, _layerNo);
}

} // namespace tut
