/*
 * Sequence.cpp
 *
 */
#include <cassert>

#include "Graphics/Transform/Sequence.hpp"

using namespace std;
using namespace boost;


namespace Graphics
{
namespace Transform
{

Sequence::Sequence(unsigned int transformsCnt):
  _seq(transformsCnt)
{
  // clean each element
  for(vector<Transformation*>::iterator it=_seq.begin();
      it!=_seq.end(); ++it)
    *it=NULL;
}


void Sequence::transform(void)
{
  for(vector<Transformation*>::iterator it=_seq.begin();
      it!=_seq.end(); ++it)
  {
    assert( (*it)!=NULL );      // this must be already set!
    (*it)->transform();         // run given transformation
  }
}

void Sequence::addTransformation(Transformation *t, unsigned int pos)
{
  assert( _seq.size()>0   );    // is there space for ANY transform?
  assert( _seq.size()>pos );    // is given position ok?
  assert( t!=NULL         );    // is given transform ok?
  assert( _seq[pos]==NULL );    // is given position free?
  _seq[pos]=t;                  // add new transformation
}

} // namespace Transform
} // namespace Graphics

