/*
 * Sequence.hpp
 *
 * abstract class representing sequence of image
 * transformations. it uses Transformation base class
 * for representing sequence's elements.
 *
 */
#ifndef INCLUDE_GRAPHICS_TRANSFORM_SEQUENCE_HPP_FILE
#define INCLUDE_GRAPHICS_TRANSFOMR_SEQUENCE_HPP_FILE

/* public header */

#include <vector>

#include "Graphics/Exception.hpp"
#include "Graphics/Transform/Transformation.hpp"


namespace Graphics
{
namespace Transform
{

class Sequence
{
public:
  virtual ~Sequence(void)
  {
  }

  // perform all pre-programmed transfomrations
  void transform(void);

protected:
  // this class should not be instantieted directly.
  Sequence(unsigned int transformsCnt);

  // adds transformation on a given position
  // NOTE: transformations cannot be changed - re-setting
  //       the same position for a second time will fail.
  void addTransformation(Transformation *t, unsigned int pos);

private:
  std::vector<Transformation*> _seq;
}; // class Sequence

} // namespace Transform
} // namespace Graphics

#endif

