/*
 * Sequence.t.cpp
 *
 */
#include <tut.h>

#include "Graphics/Transform/Sequence.hpp"


namespace Graphics
{
namespace Transform
{

struct SequenceTestClass: public Sequence
{
  struct T1: public Transformation
  {
    T1(void):
      _test(0)
    {
    }
    virtual void transform(void)
    {
      ++_test;
    }
    int _test;
  }; // struct T1

  struct T2: public Transformation
  {
    T2(void):
      _test(0)
    {
    }
    virtual void transform(void)
    {
      --_test;
    }
    int _test;
  }; // struct T1


  SequenceTestClass(void):
    Sequence(2)
  {
    addTransformation(&t1, 0);
    addTransformation(&t2, 1);
  }

  T1 t1;
  T2 t2;
};

} // namespace Transform
} // namespace Graphics


namespace tut
{
typedef Graphics::Transform::SequenceTestClass TestClass;
typedef test_group<TestClass> factory;
typedef factory::object testObj;
} // namespace tut


namespace
{
tut::factory tf("Graphics/Transform/Sequence");
}


using namespace Graphics;
using namespace Graphics::Transform;

namespace tut
{

// test if transformation works
template<>
template<>
void testObj::test<1>(void)
{
  // step 1
  transform();
  ensure( t1._test==1 && t2._test==-1 );

  // step 2
  transform();
  ensure( t1._test==2 && t2._test==-2 );
}

} // namespace tut

