/*
 * APICheck.cpp
 *
 */
#include <errno.h>

#include "System/nonint_ioctl.hpp"
#include "Graphics/V4L/API1/SystemAPI.hpp"
#include "Graphics/V4L/API1/APICheck.hpp"

using namespace System;

namespace Graphics
{
namespace V4L
{
namespace API1
{

bool isAPI1Device(int fd)
{
  struct video_capability cap;
  // check if IOCTL will succed
  if( nonint_ioctl(fd, VIDIOCGCAP, &cap)<0 )
    return false;
  // check if it is not V4L2 device
  if( nonint_ioctl(fd, VIDIOC_QUERYCAP, &cap)==0 )
    return false;

  return true;          // this is V4L1 device
}

} // namespace API1
} // namespace V4L
} // namespace Graphics

