/*
 * CaptureConfigurator.hpp
 *
 * Class for configuring capturing static images (frames) from
 * Video4Linux1 devices (/dev/video, etc...)
 *
 */
#ifndef INCLUDE_GRAPHICS_V4L_API1_CAPTURECONFIGURATOR_HPP_FILE
#define INCLUDE_GRAPHICS_V4L_API1_CAPTURECONFIGURATOR_HPP_FILE

#include "Graphics/V4L/CaptureConfigurator.hpp"



namespace Graphics
{
namespace V4L
{
namespace API1
{

//
// class for capturing of still images from V4L2 device.
//
class CaptureConfigurator: public Graphics::V4L::CaptureConfigurator
{
public:
  CaptureConfigurator(boost::shared_ptr<Device> dev);

  virtual Size configure(const Size &newSize, ColorPalette cp);

private:
  void initDevice(void);
  Size setFormat(const Size &newSize, ColorPalette cp);
}; // class CaptureConfigurator

} // namespace API1
} // namespace V4L
} // namespace Graphics

#endif

