/*
 * APICheck.cpp
 *
 */
#include <errno.h>

#include "System/nonint_ioctl.hpp"
#include "Graphics/V4L/API2/SystemAPI.hpp"
#include "Graphics/V4L/API2/APICheck.hpp"

using namespace System;

namespace Graphics
{
namespace V4L
{
namespace API2
{

bool isAPI2Device(int fd)
{
  struct v4l2_capability cap;
  if( nonint_ioctl(fd, VIDIOC_QUERYCAP, &cap)==-1 )
  {
    if(errno==EINVAL)   // not a V4L2 device?
      return false;
    else                // some other error?
      return false;
  };
  return true;          // this is V4L2 device
}

} // namespace API2
} // namespace V4L
} // namespace Graphics

