/*
 * CaptureConfigurator.hpp
 *
 * Class for configuring capturer of static images (frames) from
 * Video4Linux2 devices (/dev/video, etc...)
 *
 */
#ifndef INCLUDE_GRAPHICS_V4L_API2_CAPTURECONFIGURATOR_HPP_FILE
#define INCLUDE_GRAPHICS_V4L_API2_CAPTURECONFIGURATOR_HPP_FILE

#include "Graphics/V4L/CaptureConfigurator.hpp"



namespace Graphics
{
namespace V4L
{
namespace API2
{

//
// class for configuring V4L2 device.
//
class CaptureConfigurator: public Graphics::V4L::CaptureConfigurator
{
public:
  CaptureConfigurator(boost::shared_ptr<Device> dev);

  virtual Size configure(const Size &newSize, ColorPalette cp);

private:
  void checkDevice(void);
  void setCropping(void);
  Size setFormat(const Size &newSize, ColorPalette cp);
}; // class CaptureConfigurator

} // namespace API2
} // namespace V4L
} // namespace Graphics

#endif

