/*
 * Descriptors.hpp
 *
 */
#ifndef INCLUDE_GRAPHICS_V4L_DESCRIPTORS_HPP_FILE
#define INCLUDE_GRAPHICS_V4L_DESCRIPTORS_HPP_FILE

/* public header */

#include "System/Enum.hpp"


namespace Graphics
{
namespace V4L
{

//
// API chooser
//
struct APIType_Values
{
  typedef enum
  {
    V4L1,   // V4L 1 API
    V4L2,   // V4L 2 API
    AUTO    // autoselect best available API
  } Type;
}; // struct APIType_Values

typedef System::Enum<APIType_Values> APIType;


//
// color Palette definition
//
struct ColorPalette_Values
{
  typedef enum
  {
    //GREY,
    //HI240,
    RGB24,
    //RGB32,
    //RGB555,
    //RGB565,
    //UYVY,
    //YUV420P,
    //YUV422,
    //YUV422P
  } Type;
}; // struct ColorPalette_Values

typedef System::Enum<ColorPalette_Values> ColorPalette;

} // namespace V4L
} // namespace Graphics

#endif

