/*
 * Translations.cpp
 *
 */
#include <cassert>

#include "Graphics/V4L/API1/SystemAPI.hpp"
#include "Graphics/V4L/API2/SystemAPI.hpp"
#include "Graphics/V4L/Translations.hpp"


namespace Graphics
{
namespace V4L
{

int colorPalette2ioctlValue(ColorPalette cp)
{
  switch( cp.toInt() )
  {
    case ColorPalette::RGB24:
      return VIDEO_PALETTE_RGB24;

    default:
      assert(!"should never get here - translation is incompleat");
  } // switch(ColorPalette)
  return -1;    // this code will be never reached
} // colorPalette2ioctlValue()


int colorPalette2ioctlDataFormat(ColorPalette cp)
{
  switch( cp.toInt() )
  {
    case ColorPalette::RGB24:
      return V4L2_PIX_FMT_RGB24;

    default:
      assert(!"should never get here - translation is incompleat");
  } // switch(ColorPalette)
  return -1;    // this code will be never reached
} // colorPalette2ioctlDataFormat()


size_t colorPalettePixelSize(ColorPalette cp)
{
  switch( cp.toInt() )
  {
    case ColorPalette::RGB24:
      return 3; // 24-bits

    default:
      assert(!"should never get here - translation is incompleat");
  } // switch(ColorPalette)
  return 0;     // this code will be never reached
} // colorPalettePixelSize()

} // namespace V4L
} // namespace Graphics

