/*
 * Translations.hpp
 *
 * helpers translating enum parameters to driver-specific
 * values for V4L. at the present moment these are the same
 * values so there is no need to separete this between
 * two drivers.
 *
 */
#ifndef INCLUDE_GRAPHICS_V4L_TRANSLATIONS_HPP_FILE
#define INCLUDE_GRAPHICS_V4L_TRANSLATIONS_HPP_FILE

/* public header */

#include "Graphics/V4L/Descriptors.hpp"


namespace Graphics
{
namespace V4L
{

// converts ColorPalette to values required by
// driver in ioctl() to set color palette
int colorPalette2ioctlValue(ColorPalette cp);

// converts ColorPalette to proper data format used
// for this data
int colorPalette2ioctlDataFormat(ColorPalette cp);

// return size of single pixel for given color palette
// in bytes
size_t colorPalettePixelSize(ColorPalette cp);

} // namespace V4L
} // namespace Graphics

#endif

